using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace TraumaMod
{
    public class TraumaMod
    {
        public static void Main()
        {
			//non zombies
			
			//trauma medic
            NewNPC("Trauma Medic (Head Lamp Off)", "Medkits Included", "Trauma_Medic_Thumb.png", "Trauma_Medic_Skin.png", 0, null, 1, "Trauma_Pack_Alt.png", 0, null, 0);
			NewNPC("Trauma Medic (Head Lamp On)", "Medkits Included", "Trauma_Medic_Light_Thumb.png", "Trauma_Medic_Skin.png", 0, null, 1, "Trauma_Pack_Alt.png", 1, "Trauma_Light_5.png", 0);
			
			//trauma pilot
			NewNPC("Trauma Pilot(Head Lamp Off)", "Ready for takeoff", "Trauma_Pilot_Thumb.png", "Trauma_Pilot_Skin.png", 0, null, 1, "Trauma_Pack_Alt.png", 0, null, 0);
			NewNPC("Trauma Pilot(Head Lamp On)", "Ready for takeoff", "Trauma_Pilot_Light_Thumb.png", "Trauma_Pilot_Skin.png", 0, null, 1, "Trauma_Pack_Alt.png", 1, "Trauma_Light_4.png", 0);
			
			//trauma soldier
            NewNPC("Trauma Soldier (Head Lamp Off)", "Locked & Loaded", "Trauma_Soldier_Thumb.png", "Trauma_Soldier_Skin.png", 0, null, 1, "Trauma_Pack.png", 0, null, 0);
            NewNPC("Trauma Soldier (Head Lamp On)", "Locked & Loaded", "Trauma_Soldier_Light_Thumb.png", "Trauma_Soldier_Skin.png", 0, null, 1, "Trauma_Pack.png", 1, "Trauma_Light_1.png", -0);
			
            //trauma soldier - visor
            NewNPC("Trauma Soldier (Visor Up & Head Lamp Off)", "UV Rays Inbound", "Trauma_Soldier_Visor_Thumb.png", "Trauma_Soldier_Visor_Skin.png", 1, "Visor.png", 1, "Trauma_Pack.png", 0, null, 0);
            NewNPC("Trauma Soldier (Visor Up & Head Lamp On)", "UV Rays Inbound", "Trauma_Soldier_Visor_Light_Thumb.png", "Trauma_Soldier_Visor_Skin.png", 1, "Visor.png", 1, "Trauma_Pack.png", 1, "Trauma_Light_2.png", 0);
			
            //trauma responder
            NewNPC("Trauma Responder (Head Lamp Off)", "Defib Unit Ready", "Trauma_Responder_Thumb.png", "Trauma_Responder_Skin.png", 1, "Head_Tech.png", 1, "Trauma_Response_Pack.png", 0, null, 0);
            NewNPC("Trauma Responder (Head Lamp On)", "Defib Unit Ready", "Trauma_Responder_Light_Thumb.png", "Trauma_Responder_Skin.png", 1, "Head_Tech.png", 1, "Trauma_Response_Pack.png", 1, "Trauma_Light_3.png", 0);
			
			//zombies
			
            //trauma medic zombie
            NewNPC("Infected Trauma Medic", "Disease Inbound", "Infected_Trauma_Thumb.png", "Infected_Trauma_Skin.png", 0, null, 1, "Trauma_Pack_Alt_Bloody.png", 0, null, 1);
			
			//trauma pilot zombie
			NewNPC("Infected Trauma Pilot", "Disease Inbound", "Infected_Trauma_Pilot_Thumb.png", "Infected_Trauma_Pilot_Skin.png", 0, null, 1, "Trauma_Pack_Alt_Bloody.png", 0, null, 1);

            //trauma soldier zombie
            NewNPC("Infected Trauma Soldier", "Disease Inbound", "Infected_Trauma_Soldier_Thumb.png", "Infected_Trauma_Soldier_Skin.png", 0, null, 1, "Trauma_Pack_Bloody.png", 0, null, 1);

            //trauma soldier - visor zombie
            NewNPC("Infected Trauma Soldier (Visor Up)", "Disease Inbound", "Infected_Trauma_Soldier_Visor_Thumb.png", "Infected_Trauma_Soldier_Visor_Skin.png", 1, "Visor_Bloody.png", 1, "Trauma_Pack_Bloody.png", 0, null, 1);

            //trauma responder zombie
            NewNPC("Infected Trauma Responder", "Disease Inbound", "Infected_Trauma_Responder_Thumb.png", "Infected_Trauma_Responder_Skin.png", 1, "Head_Tech_Bloody.png", 1, "Trauma_Response_Pack_Bloody.png", 0, null, 1);
        }

        //unity seems to hate booleans so i opted for integer checks instead
        public static void NewNPC(string NPCname, string Desc, string Thumb, string SkinFile, byte HeadGear, string HeadGearFile, byte ChestGear, string ChestGearFile, byte HeadLight, string HeadLightFile, byte Infected) //11 parameters
        {
            ModAPI.Register(
                 new Modification()
                 {
                     OriginalItem = ModAPI.FindSpawnable("Human"),
                     NameOverride = NPCname,
                     NameToOrderByOverride = "TM",
                     DescriptionOverride = Desc,
                     CategoryOverride = ModAPI.FindCategory("Entities"),
                     ThumbnailOverride = ModAPI.LoadSprite("thumbnails/" + Thumb),
                     AfterSpawn = (Instance) =>
                     {
                         var skin = ModAPI.LoadTexture("sprites/characters/" + SkinFile);
                         var flesh = ModAPI.LoadTexture("humanflesh.png");
                         var bone = ModAPI.LoadTexture("humanbone.png");
                         Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                         var person = Instance.GetComponent<PersonBehaviour>();

                         person.SetBodyTextures(skin, null, null, 1);

                         //gore settings

                         person.SetBruiseColor(119, 17, 17);
                         person.SetSecondBruiseColor(7, 0, 0);
                         person.SetThirdBruiseColor(3, 0, 0);
                         person.SetRottenColour(202, 199, 104);
                         person.SetBloodColour(108, 0, 4);

                         //zombie check & toggle

                         if (Infected >= 1)
                         {
                             foreach (var body in person.Limbs)
                             {
                                 body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                                 body.IsZombie = true;
                             }
                         }

                         //accessories & lights

                         if (HeadLight >= 1)
                         {
							 string dir = $"sprites/emissive/{HeadLightFile}";
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0.0f, 0.0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                             gameObject1.transform.localScale = new Vector3(1f, 1f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite(dir, 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";
                         }

                         if (HeadGear >= 1)
                         {
                             var helmet = new GameObject("Helmet");
                             helmet.transform.SetParent(Instance.transform.Find("Head"));
                             helmet.transform.localPosition = new Vector3(0, 0f);
                             helmet.transform.localScale = new Vector3(1f, 1f);
                             var helmetSprite = helmet.AddComponent<SpriteRenderer>();
                             helmetSprite.sprite = ModAPI.LoadSprite("sprites/accessories/" + HeadGearFile);
                             helmetSprite.sortingLayerName = "Top";
                         }

                         if (ChestGear >= 1)
                         {
                             var backpack = new GameObject("Backpack");
                             backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                             backpack.transform.localPosition = new Vector3(0, 0f);
                             backpack.transform.localScale = new Vector3(1f, 1f);
                             var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                             backpackSprite.sprite = ModAPI.LoadSprite("sprites/accessories/" + ChestGearFile);
                         }
                     }
                 }
            );
        }
    }
}